#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

from ..attribute import DataType
from datetime import datetime
from .eventgenerator import fire_events
import math
from .nonetypevalue import get_none_value_by_type
import re
from tango import AttrQuality


PI = math.pi
SIN = math.sin
COS = math.cos
ACOS = math.acos
ASIN = math.asin
ATAN = math.atan
TAN = math.tan
LOG = math.log
ATAN2 = math.atan2
SQRT = math.sqrt
ABS = math.fabs
POW = math.pow


class AttributeInterpreter:
    """
With the data read from the card and the information of the attributes, store
the information in the appropriate place and launch the tango events of the
attributes that have a newer value.
    """
    __device = None
    __multiattr_obj = None
    _attributes_dict = None

    def __init__(self, tango_device, attributes_dct):
        self.__device = tango_device
        self.__multiattr_obj = self.__device.get_device_attr()
        self._attributes_dict = attributes_dct

    def process_read_data(self, read_data, read_ts):
        """
Once in has proceed with a read of the hardware, this method reviews this read
to resolve the necessary formulas, internally store the information and emit
the tango events when it is required because the value has changed.

:param read_data: dictionary where the keys are the register number and the
                  value corresponds with what has been read from the fpga
:param read_ts: time reference from when the read was made
:return: tuple with three velues (the number of events emitted, the number of
         attributes that didn't have a value change, and the time used to do
         this process).
        """
        t_0 = datetime.now()
        events_triggered = 0
        no_value_change = 0
        for attribute_name, attribute_obj in self._attributes_dict.items():
            if attribute_obj.address not in read_data:
                continue  # nothing to do with unread registers
            READ_VALUE = read_data[attribute_obj.address]
            ret_value = self.apply_read_formula(attribute_obj, READ_VALUE)
            ret_value = self.cast_read_value(attribute_obj, ret_value)
            if attribute_obj.value == ret_value:
                no_value_change += 1
                continue
            attribute_obj.set_value(ret_value, read_ts)
            fire_events(self.__device, attribute_obj.name, ret_value,
                        timestamp=attribute_obj.last_update_float,
                        data_type=attribute_obj.data_type)
            events_triggered += 1
            tango_attr_obj = self.__multiattr_obj.get_attr_by_name(
                attribute_obj.name)
            value, timestamp, quality = build_value_timestamp_quality(
                attribute_obj)
            tango_attr_obj.set_value_date_quality(value, timestamp, quality)
        t_delta = datetime.now()-t_0
        return events_triggered, no_value_change, t_delta

    def process_internal_formulas(self, attribute__obj_lst):
        """
After the processing of a new read of the hardware and once all the information
from the fpga is already in the internal structures, it can be review if the
attributes without a link with a register (but that in their formula references
other attributes) have to refresh its value.

:param attribute__obj_lst: list of internal representation of the attributes
                           that doesn't have a register linked, but its formula
                           specifies and uses other attributes
:return: tuple with three velues (the number of events emitted, the number of
         attributes that didn't have a value change, and the time used to do
         this process).
        """
        t_0 = datetime.now()
        events_triggered = 0
        no_value_change = 0
        for attribute_obj in attribute__obj_lst:
            READ_VALUE = attribute_obj.value
            ret_value = self.apply_read_formula(attribute_obj, READ_VALUE)
            ret_value = self.cast_read_value(attribute_obj, ret_value)
            if attribute_obj.value == ret_value:
                no_value_change += 1
                continue
            attribute_obj.set_value(ret_value, datetime.now())
            fire_events(self.__device, attribute_obj.name, ret_value,
                        timestamp=attribute_obj.last_update_float,
                        data_type=attribute_obj.data_type)
            events_triggered += 1
            tango_attr_obj = self.__multiattr_obj.get_attr_by_name(
                attribute_obj.name)
            value, timestamp, quality = build_value_timestamp_quality(
                attribute_obj)
            tango_attr_obj.set_value_date_quality(value, timestamp, quality)
        t_delta = datetime.now()-t_0
        return events_triggered, no_value_change, t_delta

    def apply_read_formula(self, internal_attr_obj, READ_VALUE):
        """
Given an internal object and a read value (even represents a register in the
fpga or a purely internal), if this structure has a formula for the read action,
just apply it. If it doesn't have a formula, be transparent and return the
incoming value.

:param internal_attr_obj: internal representation of an attribute
:param READ_VALUE: original value read from the fpga
:return: the input value if there is no formula or the result of apply it
        """
        formula = internal_attr_obj.fread[0]
        # TODO: write works with nested formulas
        if formula is not None and formula != "":
            formula = replace_attributes(formula, self._attributes_dict)
            try:
                return eval(formula)
            except Exception as exception:
                self.__device.error_stream(
                    f"In apply_read_formula(): {internal_attr_obj.name} "
                    f"*** Error in formula for {formula} "
                    f"(READ_VALUE={READ_VALUE} from address "
                    f"0x{internal_attr_obj.address:X}): {exception}")
                return
        else:
            return READ_VALUE

    @staticmethod
    def cast_read_value(internal_attr_obj, value):
        """
Given an internal attribute and a value, do the cast transformation base on the
data type this attribute has.

:param internal_attr_obj: internal representation of an attribute
:param value: some representation of the value that may need a cast
:return: conversion of the input based on the type in the internal
         representation of the attribute
        """
        if value is None:
            return
        attr_type = internal_attr_obj.data_type
        if attr_type == DataType.bool:
            return bool(value)
        elif attr_type in [DataType.short, DataType.long]:
            return int(value)
        elif attr_type in [DataType.float, DataType.volts, DataType.angle]:
            return float(value)
        elif attr_type == DataType.string:
            return str(value)


def replace_attributes(formula, attributes_dct):
    """
Given a formula, check if it mentions other attributes to replace their label
with the value it has stored.

:param formula: string of the formula with attribute names bounded by # symbol
:param attributes_dct: dictionary with the internal attributes that can be
       used in the formula.
:return: the original string with a replacement with the value on the place
         where the references to attributes where.
    """
    replaced_formula = formula
    for attr in attributes_dct.keys():
        att_found = re.findall(r'#(.*?)#', replaced_formula)
        if len(att_found) > 0:
            for att_f in att_found:
                att_fcompressed = att_f.replace(" ", "")
                replaced_formula = replaced_formula.replace(
                    f"#{att_f}#",
                    f"self._attributes_dict['{att_fcompressed}'].value")
    return replaced_formula


def build_value_timestamp_quality(attribute_obj):
    """
Based on the internal attribute representation generate the triplet
value, timestamp, quality used in tango

:param attribute_obj: internal representation of an attribute
:return: triplet value, timestamp, quality
    """
    if attribute_obj.value is None:
        value = get_none_value_by_type(attribute_obj.data_type)
        timestamp = float(datetime.now().strftime('%s.%f'))
        quality = AttrQuality.ATTR_INVALID
    else:
        value = attribute_obj.value
        if attribute_obj.last_update is None:
            timestamp = float(datetime.now().strftime('%s.%f'))
        else:
            timestamp = attribute_obj.last_update_float
        quality = AttrQuality.ATTR_VALID
    return value, timestamp, quality
